#!/usr/bin/python
#Enumerate GridFTP server and WEB Service Container
#On TCP port 2811 and 8443
#This release is part of Grid Toolkit
#Copyright IPSECS (c) 2010 http://ipsecs.com

GRIDPORT=[2811,8443]
import sys,threading,socket,os,re
from string import atoi

class scanner(threading.Thread):
 tlist = []
 log = "./logs/headnode.log"
 maxthreads = 50
 timeout = 3
 evnt = threading.Event()
 lck = threading.Lock()
 
 def __init__(self,port,host):
  threading.Thread.__init__(self)
  self.port = port
  self.host = host

 def run(self):
  logfile = open(scanner.log,"a");
  s = socket.socket(socket.AF_INET,socket.SOCK_STREAM,0)
  s.settimeout(scanner.timeout)
  try:
   s.connect((self.host, self.port))
   get = s.recv(1024)
   print "[OPEN] "+self.host+" on "+str(self.port)+"/tcp : "+get.rstrip()
   record = "[OPEN] "+self.host+" on "+str(self.port)+"/tcp : "+get.rstrip()+"\n"
   logfile.write(record)
   s.close()
  except:
   print "[CLOSE] "+self.host+" on "+str(self.port)+"/tcp"
  logfile.close()
  scanner.lck.acquire()
  scanner.tlist.remove(self)
  if len(scanner.tlist) == scanner.maxthreads-1:
   scanner.evnt.set()
   scanner.evnt.clear()
  scanner.lck.release()

 def newthread(pn,hst):
  scanner.lck.acquire()
  sc = scanner(pn,hst)
  scanner.tlist.append(sc)
  scanner.lck.release()
  sc.start()
 newthread = staticmethod(newthread)

def usage():
 print "Usage : "
 print "run [low-high/A Class] [low-high/B Class] [low-high/C Class]"
 print "run 192-192 168-170 1-10 (SCAN 192.168.1.1 up to 192.170.10.254)"
 print "run 192-192 168-168 1-3 (SCAN 192.168.1.1 up to 192.168.3.254)"
 quit()

def doCheck(rangeIP):
 ADDRS=rangeIP.split("-")
 if ADDRS[0] > ADDRS[1]:
  print "LOW must be lower than HIGH!"
  quit()
 else:
  return(ADDRS)

def main(argv):
 if len(sys.argv) < 2 or len(sys.argv) > 4:
  usage()
 IPADDR=[]
 for i in range(1,len(sys.argv)):
  IPADDR.append(doCheck(sys.argv[i]))

 #How to make this loop more efficient?
 #Seem so nasty
 #C-Class range
 if len(IPADDR)==3:
  print "[+] Building IP address"
  for bit8 in range(atoi(IPADDR[0][0]),atoi(IPADDR[0][1])+1):
   for bit16 in range(atoi(IPADDR[1][0]),atoi(IPADDR[1][1])+1):
    for bit24 in range(atoi(IPADDR[2][0]),atoi(IPADDR[2][1])+1):
     for bit32 in range(1,256):
      ipaddress=str(bit8) + "." + str(bit16) + "." + str(bit24) + "." + str(bit32)
      print "[+] Scanning " + ipaddress
      for PORT in GRIDPORT:
       scanner.lck.acquire()
       if len(scanner.tlist) >= scanner.maxthreads:
        scanner.lck.release()
        scanner.evnt.wait()
       else:
        scanner.lck.release()
        scanner.newthread(int(PORT),ipaddress)
  for sc in scanner.tlist:
   sc.join()


 #B-Class range
 if len(IPADDR)==2:
  print "[+] Building IP address"
  for bit8 in range (atoi(IPADDR[0][0]),atoi(IPADDR[0][1])+1):
   for bit16 in range(atoi(IPADDR[1][0]),atoi(IPADDR[1][1])+1):
    for bit24 in range(1,256):
     for bit32 in range(1,256):
      ipaddress=str(bit8) + "." + str(bit16) + "." + str(bit24) + "." + str(bit32)
      print "[+] Scanning " + ipaddress
      for PORT in GRIDPORT:
       scanner.lck.acquire()
       if len(scanner.tlist) >= scanner.maxthreads:
        scanner.lck.release()
        scanner.evnt.wait()
       else:
        scanner.lck.release()
        scanner.newthread(int(PORT),ipaddress)
  for sc in scanner.tlist:
   sc.join()

 #A-Class range
 if len(IPADDR)==1:
  print "[+] Building IP address"
  for bit8 in range (atoi(IPADDR[0][0]),atoi(IPADDR[0][1])+1):
   for bit16 in range(1,256):
    for bit24 in range(1,256):
     for bit32 in range(1,256):
      ipaddress=str(bit8) + "." + str(bit16) + "." + str(bit24) + "." + str(bit32)
      print "[+] Scanning " + ipaddress
      for PORT in GRIDPORT:
       scanner.lck.acquire()
       if len(scanner.tlist) >= scanner.maxthreads:
        scanner.lck.release()
        scanner.evnt.wait()
       else:
        scanner.lck.release()
        scanner.newthread(int(PORT),ipaddress)
  for sc in scanner.tlist:
   sc.join()

if __name__ == "__main__":
 main(sys.argv[1:])
